<template>
    <div class="product">
        <button class="ui right floated button positive" v-on:click="open('#addProduct')">+ Add new procut</button>
        <h1>Categories</h1>
        <table class="ui table">
            <thead>
            <tr>
                <th class="id">#</th>
                <th>Product</th>
                <th>Category</th>
                <th><!-- Actions --></th>
            </tr>
            </thead>
            <tbody>
            <tr v-for="product in products">
                <td class="id">{{product.id}}</td>
                <td>{{product.name}}</td>
                <td>{{product.category.name}}</td>
                <td>
                    <button class="ui icon negative button" @click="deleteProduct(product.id)"><i
                            class="trash alternate icon"></i></button>
                </td>
            </tr>
            </tbody>
        </table>

        <div class="ui modal" id="addProduct">
            <i class="close icon"></i>
            <div class="header">
                Add product
            </div>
            <div class="content">
                <form class="ui form">
                    <div class="field">
                        <label>Product</label>
                        <input ref="product_name" :value="product.name"/>
                    </div>
                    <div class="field">
                        <label>Category</label>
                        <select v-model="category_id">
                            <option disabled value="">Please select one</option>
                            <option v-for="category in categories" v-bind:value="category.id">
                                {{ category.name }}
                            </option>
                        </select>
                    </div>
                </form>
            </div>
            <div class="actions">
                <div class="ui primary button" @click="close('#addProduct')">
                    Close
                </div>
                <div class="ui positive button" @click="save()">
                    Save
                </div>
            </div>
        </div>
    </div>
</template>

<script>
    export default {
        name: "product",
        data() {
            return {
                showModal: false,
                products: null,
                product: {
                    name: null
                },
                category_id: null,
                categories: null
            };
        },
        mounted() {
            return this.$http.get('./api/product/list.json').then((response) => {
                this.products = response.body;
                this.$http.get('./api/category/list.json').then((response) => {
                    this.categories = response.body;
                });
            }, function () {
                alert('Error');
            });
        },
        methods: {
            show(id) {
                this.$http.get('./api/product/read/' + id).then((response) => {
                    this.products = response.body;
                    this.open('#viewCategory');
                }, function () {
                    alert('error');
                });
            },
            save() {
                let data = {
                    name: this.$refs['product_name'].value,
                    category_id: this.category_id
                };

                this.$http.post('./api/product/create', data).then((response) => {
                    this.products = response.body;
                }, function () {
                    alert('error');
                });
            },
            deleteProduct(id) {
                if (confirm('Do you want to delete product?')) {
                    this.$http.post('./api/product/delete', {id: id}).then((response) => {
                        this.products = response.body;
                    }, function () {
                        alert('error');
                    });
                }
            },
            open(element) {
                jQuery(element).modal('show');
                this.showModal = true;
            },
            close(element) {
                this.showModal = false;
                jQuery(element).modal('hide');
            }
        }
    }
</script>

<style scoped>
    .id {
        width: 5%;
    }
</style>